<template lang="pug">

section.container.news

  h1.main-heading Новости компании

  el-breadcrumb.mb-20(separator-class='el-icon-arrow-right')
    el-breadcrumb-item(:to="{ path: '/' }") Главная
    el-breadcrumb-item Новости компании

  p(v-if='!news.news.length') Нет доступных новостей.
  .row
    app-news.news__item.mb-40(
      v-for="(item, index) in news.news"
      :ref='`news-${index}`'
      :class="index === 0 ? 'col-12' : 'col-md-6 col-sm-12'"
      :cover="item.cover"
      :heading="item.heading"
      :time="item.created_at"
      :slug="item.slug"
      :key="item.id")

  .activity__block(v-if='news.pagination && news.pagination.totalPageCount > news.pagination.perPage')
    el-pagination.public-pagination(
      layout='prev, pager, next'
      @current-change='changePage'
      :current-page="news.pagination.currentPage"
      :page-size='news.pagination.perPage'
      :total='news.pagination ? news.pagination.totalPageCount : 0'
      background)

</template>

<script>
import { mapMutations } from 'vuex';

import AppNews from '../../components/public/NewsItem';

export default {
  name: 'News',
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/news/public', {
      params: {
        pagination: {
          perPage: 18,
          currentPage: 1
        }
      }
    });
    return { news: data };
  },
  head() {
    return {
      title: 'Новости компании | АО «Шувалово»'
    };
  },
  components: {
    'app-news': AppNews
  },
  data() {
    return {
      page: 1,
      perPage: 18
    };
  },
  mounted() {
    this.SET_LOADING(false);
    this.$nextTick(() => {
      window.addEventListener('resize', this.mainNewsClass);
    });
    this.mainNewsClass();
  },
  methods: {
    ...mapMutations(['SET_LOADING']),
    mainNewsClass() {
      if (this.$currentViewport.label !== 'mobile') {
        if (this.$refs['news-0'][0]) {
          this.$refs['news-0'][0].$el.classList.add('main-news');
        }
      } else {
        if (this.$refs['news-0'][0]) {
          this.$refs['news-0'][0].$el.classList.remove('main-news');
        }
      }
    },
    changePage(value) {
      this.page = value;
      this.SET_LOADING(true);
      this.$axios
        .get('/api/v1/news/public', {
          params: {
            pagination: {
              perPage: this.perPage,
              currentPage: value
            }
          }
        })
        .then(data => {
          this.news = data.data;
          this.SET_LOADING(false);
          window.scrollTo(0, 0);
        });
    }
  }
};
</script>
